////////////////////////////////////////////////////////////////////////////

#include "18F452.h"

#fuses HS,NOWDT,NOPROTECT,NOLVP,NODEBUG

#use delay(clock=48000000)

#include "GLCD_35.c"

SET_TRIS_D(0b11111111); // Entrata ADC
SET_TRIS_E(0b00000001); // RE0=INTR RE1=WR RE2=RD

/////////////////////////////////////////////////////////////////////////////

char strRD0[]= "RD0 =";
char strRD1[]= "RD1 =";
char strRD2[]= "RD2 =";
char strRD3[]= "RD3 =";
char strRD4[]= "RD4 =";
char strRD5[]= "RD5 =";
char strRD6[]= "RD6 =";
char strRD7[]= "RD7 =";
char strZero[]= "0";
char strUno[]= "1";
char strVcc[]= "Vcc=";
char strVal[9];
char strOldVal[9];
 
//////////////////////////////////////////////////////////////////////////////

main(){

  int8 data_D;
  int8 data_E;
  float Valore; 

  glcd_init(ON);

  glcd_line( 0, 63, 127, 63, ON);  // Linee orizzontali
  glcd_line( 0, 0, 127, 0, ON);

  glcd_line( 0, 0, 0, 63, ON);     // Linee verticali
  glcd_line( 127, 0, 127, 63, ON);

  glcd_text35(4,6,strRD0,ON);      // Scrivi testo
  glcd_text35(4,12,strRD1,ON);
  glcd_text35(4,18,strRD2,ON);
  glcd_text35(4,24,strRD3,ON);
  glcd_text35(4,30,strRD4,ON);
  glcd_text35(4,36,strRD5,ON);
  glcd_text35(4,42,strRD6,ON);
  glcd_text35(4,48,strRD7,ON);
  glcd_text35(40,6,strVcc,ON);

Ciclo:

  output_high(PIN_E1);             // Impulso x ADC WI
  delay_ms(2);
  output_low(PIN_E1);
  delay_ms(2);
  output_high(PIN_E1);


Attendi:                          // Aspetta consenso ADC INT    
   data_E=input_e();
   if(bit_test(data_E,0)){
      goto Attendi;
       }
   data_D=input_d();             // Cancella & scrivi nuovi valori 
   if (bit_test(data_D,0)){
       glcd_text35(28,6,strZero,OFF);
       glcd_text35(28,6,strUno,ON);
       }else{
       glcd_text35(28,6,strUno,OFF);
       glcd_text35(28,6,strZero,ON);
       }
   if (bit_test(data_D,1)){
       glcd_text35(28,12,strZero,OFF);
       glcd_text35(28,12,strUno,ON);
       }else{
       glcd_text35(28,12,strUno,OFF);
       glcd_text35(28,12,strZero,ON);
       }
   if (bit_test(data_D,2)){
       glcd_text35(28,18,strZero,OFF);
       glcd_text35(28,18,strUno,ON);
       }else{
       glcd_text35(28,18,strUno,OFF);
       glcd_text35(28,18,strZero,ON);
       }

   if (bit_test(data_D,3)){
       glcd_text35(28,24,strZero,OFF);
       glcd_text35(28,24,strUno,ON);
       }else{
       glcd_text35(28,24,strUno,OFF);
       glcd_text35(28,24,strZero,ON);
       }
   if (bit_test(data_D,4)){
       glcd_text35(28,30,strZero,OFF);
       glcd_text35(28,30,strUno,ON);
       }else{
       glcd_text35(28,30,strUno,OFF);
       glcd_text35(28,30,strZero,ON);
       }

   if (bit_test(data_D,5)){
       glcd_text35(28,36,strZero,OFF);
       glcd_text35(28,36,strUno,ON);
       }else{
       glcd_text35(28,36,strUno,OFF);
       glcd_text35(28,36,strZero,ON);
       }
   if (bit_test(data_D,6)){
       glcd_text35(28,42,strZero,OFF);
       glcd_text35(28,42,strUno,ON);
       }else{
       glcd_text35(28,42,strUno,OFF);
       glcd_text35(28,42,strZero,ON);
       }
   if (bit_test(data_D,7)){
       glcd_text35(28,48,strZero,OFF);
       glcd_text35(28,48,strUno,ON);
       }else{
       glcd_text35(28,48,strUno,OFF);
       glcd_text35(28,48,strZero,ON);
       }

       Valore =(float)(data_D/5)/10;         
       sprintf(strVal,"%f",Valore);      // Conversione in stringa
       strVal[4] = '\0';                  // Limita a due decimali 
       glcd_text35(58,6,strOldVal,OFF);
       glcd_text35(58,6,strVal,ON); 
       sprintf(strOldVal,"%f",Valore); 
       strOldVal[4]= '\0'; 
       delay_ms(200);

  goto Ciclo;

}
